package com.fossgalaxy.games.tbs.actions;

import com.fossgalaxy.games.tbs.GameState;
import com.fossgalaxy.games.tbs.entity.Entity;
import com.fossgalaxy.games.tbs.order.MineOrder;
import com.fossgalaxy.games.tbs.order.Order;
import com.fossgalaxy.games.tbs.parameters.ResourceType;
import com.fossgalaxy.object.annotations.ObjectDef;
import org.codetome.hexameter.core.api.CubeCoordinate;


/**
 * Created by pwillic on 18/05/2018.
 */
public class MineByProperty extends AbstractMineAction {
    private final String propertyTag;

    @ObjectDef("Mine")
    public MineByProperty(ResourceType resourceType) {
        super(resourceType);
        this.propertyTag = "mine-" + resourceType.getName();
    }

    @Override
    public Order generateOrder(CubeCoordinate co, GameState s) {
        Entity current = s.getEntityAt(co);
        return new MineOrder(resourceType, current.getProperty(propertyTag));
    }

}
